| The Gaudi Framework v27r1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Private Types | Private Member Functions | Private Attributes | List of all members
PartitionSwitchAlg Class Reference

Small algorithm which switches the partition of a configurable multi-service. More...

Inheritance diagram for PartitionSwitchAlg:
[legend]
Collaboration diagram for PartitionSwitchAlg:
[legend]

## Public Member Functions
| PartitionSwitchAlg (const std::string &name, ISvcLocator *pSvcLocator)
| Standard algorithm constructor. More...
| ~PartitionSwitchAlg () override=default
| Standard Destructor. More...
STATUS | initialize () override
| Initialize. More...
STATUS | finalize () override
| Finalize. More...
STATUS | execute () override
| Execute procedure. More...
STATUS | create (CSTR nam, CSTR typ) override
| Create a partition object. The name identifies the partition uniquely. More...
STATUS | create (CSTR nam, CSTR typ, IInterface *&pPartition) override
| Create a partition object. The name identifies the partition uniquely. More...
STATUS | drop (CSTR nam) override
| Drop a partition object. The name identifies the partition uniquely. More...
STATUS | drop (IInterface *pPartition) override
| Drop a partition object. The name identifies the partition uniquely. More...
STATUS | activate (CSTR nam) override
| Activate a partition object. The name identifies the partition uniquely. More...
STATUS | activate (IInterface *pPartition) override
| Activate a partition object. More...
STATUS | get (CSTR nam, IInterface *&pPartition) const override
| Access a partition object. The name identifies the partition uniquely. More...
STATUS | activePartition (std::string &nam, IInterface *&pPartition) const override
| Access the active partition object. More...
Public Member Functions inherited from extends< Algorithm, IPartitionControl >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| ~extends () override=default
| Virtual destructor. More...
Public Member Functions inherited from Algorithm
| Algorithm (const std::string &name, ISvcLocator *svcloc, const std::string &version=PACKAGE_VERSION)
| Constructor. More...
| ~Algorithm () override=default
| Destructor. More...
StatusCode | sysStart () override
| Reinitialization method invoked by the framework. More...
StatusCode | sysInitialize () override
| Initialization method invoked by the framework. More...
StatusCode | sysReinitialize () override
| Reinitialization method invoked by the framework. More...
StatusCode | sysRestart () override
| Restart method invoked by the framework. More...
StatusCode | sysExecute () override
| The actions to be performed by the algorithm on an event. More...
StatusCode | sysStop () override
| System stop. More...
StatusCode | sysFinalize () override
| System finalization. More...
StatusCode | sysBeginRun () override
| beginRun method invoked by the framework. More...
StatusCode | sysEndRun () override
| endRun method invoked by the framework. More...
const std::string & | name () const override
| The identifying name of the algorithm object. More...
const Gaudi::StringKey & | nameKey () const override
const std::string & | type () const override
| The type of the algorithm object. More...
void | setType (const std::string &type) override
const std::string & | version () const override
unsigned int | index () const override
StatusCode | configure () override
| Dummy implementation of IStateful::configure() method. More...
StatusCode | terminate () override
| Dummy implementation of IStateful::terminate() method. More...
StatusCode | initialize () override
| the default (empty) implementation of IStateful::initialize() method More...
StatusCode | start () override
| the default (empty) implementation of IStateful::start() method More...
StatusCode | stop () override
| the default (empty) implementation of IStateful::stop() method More...
StatusCode | finalize () override
| the default (empty) implementation of IStateful::finalize() method More...
StatusCode | reinitialize () override
| the default (empty) implementation of IStateful::reinitialize() method More...
StatusCode | restart () override
| the default (empty) implementation of IStateful::restart() method More...
Gaudi::StateMachine::State | FSMState () const override
| returns the current state of the algorithm More...
Gaudi::StateMachine::State | targetFSMState () const override
| returns the state the algorithm will be in after the ongoing transition More...
bool | isExecuted () const override
| Has this algorithm been executed since the last reset? More...
void | setExecuted (bool state) override
| Set the executed flag to the specified state. More...
void | resetExecuted () override
| Reset the executed state of the Algorithm for the duration of the current event. More...
StatusCode | beginRun () override
| Algorithm begin run. More...
StatusCode | endRun () override
| Algorithm end run. This method is called at the end of the event loop. More...
bool | isEnabled () const override
| Is this algorithm enabled or disabled? More...
bool | filterPassed () const override
| Did this algorithm pass or fail its filter criterion for the last event? More...
void | setFilterPassed (bool state) override
| Set the filter passed flag to the specified state. More...
int | errorCount () const
| Get the number of failures of the algorithm. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
SmartIF< IService > | service (const std::string &name, const bool createIf=true, const bool quiet=false) const
| Return a pointer to the service identified by name (or "type/name") More...
template<class T >
SmartIF< T > | service (const std::string &name, bool createIf=true, bool quiet=false) const
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
SmartIF< IChronoStatSvc > & | chronoSvc () const
| The standard Chrono & Stat service, Return a pointer to the service if present. More...
SmartIF< IChronoStatSvc > & | chronoStatService () const
| Obsoleted name, kept due to the backwards compatibility. More...
SmartIF< IDataProviderSvc > & | detSvc () const
| The standard detector data service. More...
SmartIF< IDataProviderSvc > & | detDataService () const
| Obsoleted name, kept due to the backwards compatibility. More...
SmartIF< IConversionSvc > & | detCnvSvc () const
| The standard detector data persistency conversion service. More...
SmartIF< IConversionSvc > & | detDataCnvService () const
| Obsoleted name, kept due to the backwards compatibility. More...
SmartIF< IDataProviderSvc > & | eventSvc () const
| The standard event data service. More...
SmartIF< IDataProviderSvc > & | evtSvc () const
| shortcut for method eventSvc More...
SmartIF< IDataProviderSvc > & | eventDataService () const
| Obsoleted name, kept due to the backwards compatibility. More...
SmartIF< IConversionSvc > & | eventCnvSvc () const
| The standard event data persistency conversion service. More...
SmartIF< IConversionSvc > & | eventDataCnvService () const
| Obsoleted name, kept due to the backwards compatibility. More...
SmartIF< IHistogramSvc > & | histoSvc () const
| The standard histogram service. More...
SmartIF< IHistogramSvc > & | histogramDataService () const
| Obsoleted name, kept due to the backwards compatibility. More...
SmartIF< INTupleSvc > & | ntupleSvc () const
| The standard N tuple service. More...
SmartIF< INTupleSvc > & | ntupleService () const
| Obsoleted name, kept due to the backwards compatibility. More...
SmartIF< IRndmGenSvc > & | randSvc () const
| AIDA-based NTuple service Returns a pointer to the AIDATuple service if present. More...
SmartIF< IToolSvc > & | toolSvc () const
| The standard ToolSvc service, Return a pointer to the service if present. More...
SmartIF< IExceptionSvc > & | exceptionSvc () const
| Get the exception Service. More...
SmartIF< IAlgContextSvc > & | contextSvc () const
| get Algorithm Context Service More...
SmartIF< ITimelineSvc > & | timelineSvc () const
SmartIF< ISvcLocator > & | serviceLocator () const override
| The standard service locator. More...
SmartIF< ISvcLocator > & | svcLoc () const
| shortcut for method serviceLocator More...
SmartIF< IHiveWhiteBoard > & | whiteboard () const
bool | registerContext () const
| register for Algorithm Context Service? More...
StatusCode | createSubAlgorithm (const std::string &type, const std::string &name, Algorithm *&pSubAlg)
| Create a sub algorithm. More...
const std::vector< Algorithm * > * | subAlgorithms () const
| List of sub-algorithms. Returns a pointer to a vector of (sub) Algorithms. More...
std::vector< Algorithm * > * | subAlgorithms ()
| List of sub-algorithms. Returns a pointer to a vector of (sub) Algorithms. More...
StatusCode | setProperty (const Property &p) override
| Implementation of IProperty::setProperty. More...
StatusCode | setProperty (const std::string &s) override
| Implementation of IProperty::setProperty. More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| Implementation of IProperty::setProperty. More...
StatusCode | getProperty (Property *p) const override
| Implementation of IProperty::getProperty. More...
const Property & | getProperty (const std::string &name) const override
| Implementation of IProperty::getProperty. More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| Implementation of IProperty::getProperty. More...
const std::vector< Property * > & | getProperties () const override
| Implementation of IProperty::getProperties. More...
bool | hasProperty (const std::string &name) const override
| Implementation of IProperty::hasProperty. More...
PropertyMgr * | getPropertyMgr ()
StatusCode | setProperties ()
| Set the algorithm's properties. More...
template<class T >
Property * | declareProperty (const std::string &name, T &property, const std::string &doc="none") const
| Declare the named property. More...
Property * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="") const
| Declare remote named properties. More...
template<class T >
Property * | declareProperty (const std::string &name, ToolHandle< T > &hndl, const std::string &doc="none") const
template<class T >
Property * | declareProperty (const std::string &name, ToolHandleArray< T > &hndlArr, const std::string &doc="none") const
SmartIF< IMonitorSvc > & | monitorSvc () const
| Access the monitor service. More...
template<class T >
void | declareInfo (const std::string &name, const T &var, const std::string &desc) const
| Declare monitoring information. More...
void | declareInfo (const std::string &name, const std::string &format, const void *var, int size, const std::string &desc) const
| Declare monitoring information (special case) More...
template<class TYPE >
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
EventContext * | getContext () const
| get the context More...
void | setContext (EventContext *context)
| set the context More...
virtual std::vector< Gaudi::DataHandle * > | inputHandles () const override
virtual std::vector< Gaudi::DataHandle * > | outputHandles () const override
virtual const DataObjIDColl & | extraInputDeps () const override
virtual const DataObjIDColl & | extraOutputDeps () const override
virtual void | acceptDHVisitor (IDataHandleVisitor *) const override
const DataObjIDColl & | inputDataObjs () const
const DataObjIDColl & | outputDataObjs () const
void | commitHandles () override
void | registerTool (IAlgTool *tool) const
void | deregisterTool (IAlgTool *tool) const
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
const std::vector< IAlgTool * > & | tools () const
bool | isClonable () const override
| Specifies the clonability of the algorithm. More...
unsigned int | cardinality () const override
| Return the cardinality. More...
const std::vector< std::string > & | neededResources () const override
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
Public Member Functions inherited from extend_interfaces< Interfaces...>
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Private Types
using | STATUS = StatusCode
using | CSTR = const std::string &

## Private Member Functions
StatusCode | log_ (StatusCode sc, const std::string &msg) const
template<typename... FArgs, typename... Args>
StatusCode | fwd_ (StatusCode(IPartitionControl::*fun)(FArgs...), Args &&...args)
template<typename... FArgs, typename... Args>
StatusCode | fwd_ (StatusCode(IPartitionControl::*fun)(FArgs...) const, Args &&...args) const

## Private Attributes
std::string | m_partName
| Job option to set the requested partition name. More...
std::string | m_toolType
| Job option to set the tool manipulating the multi-service name. More...
IPartitionControl * | m_actor = nullptr
| reference to Partition Controller More...

## Additional Inherited Members
Public Types inherited from extends< Algorithm, IPartitionControl >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces...>
| Typedef to the base of this class. More...
Public Types inherited from Algorithm
typedef Gaudi::PluginService::Factory< IAlgorithm *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces...>
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids...>::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from Algorithm
virtual void | declareInput (Gaudi::DataHandle *im) override
virtual void | declareOutput (Gaudi::DataHandle *im) override
std::vector< IAlgTool * > & | tools ()
bool | isInitialized () const override
| Has the Algorithm already been initialized? More...
bool | isFinalized () const override
| Has the Algorithm already been finalized? More...
void | setIndex (const unsigned int &idx) override
| set instantiation index of Alg More...
Protected Member Functions inherited from CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > >
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from Algorithm
EventContext * | m_event_context
| Event specific data for multiple event processing. More...
SmartIF< PropertyMgr > | m_propertyMgr
| For management of properties. More...
std::unique_ptr< IDataHandleVisitor > | m_updateDataHandles
| Hook for for derived classes to provide a custom visitor for data handles. More...

## Detailed Description

Small algorithm which switches the partition of a configurable multi-service.

The algorithm can be part of a sequence, which allows for e.g. buffer tampering.

Author
  : M.Frank

Version
  : 1.0

Definition at line 24 of file PartitionSwitchAlg.cpp.

## Member Typedef Documentation

using PartitionSwitchAlg::CSTR = const std::string&
| private

Definition at line 28 of file PartitionSwitchAlg.cpp.

using PartitionSwitchAlg::STATUS = StatusCode
| private

Definition at line 27 of file PartitionSwitchAlg.cpp.

## Constructor & Destructor Documentation

PartitionSwitchAlg::PartitionSwitchAlg | ( | const std::string & | name,
|  | ISvcLocator * | pSvcLocator
| ) |  |
| inline

Standard algorithm constructor.

Definition at line 42 of file PartitionSwitchAlg.cpp.

43 : base_class(name, pSvcLocator)
44 {
45 declareProperty("Partition", m_partName);
46 declareProperty("Tool", m_toolType="PartitionSwitchTool");
47 }
Algorithm::declareProperty
Property * declareProperty(const std::string &name, T &property, const std::string &doc="none") const
Declare the named property.
Definition: Algorithm.h:426
extends< Algorithm, IPartitionControl >::base_class
extends base_class
Typedef to this class.
Definition: extends.h:14
PartitionSwitchAlg::m_partName
std::string m_partName
Job option to set the requested partition name.
Definition: PartitionSwitchAlg.cpp:33
PartitionSwitchAlg::m_toolType
std::string m_toolType
Job option to set the tool manipulating the multi-service name.
Definition: PartitionSwitchAlg.cpp:35

PartitionSwitchAlg::~PartitionSwitchAlg | ( |  | ) |
| override default

Standard Destructor.

## Member Function Documentation

STATUS PartitionSwitchAlg::activate | ( | CSTR | nam | ) |
| inline override

Activate a partition object. The name identifies the partition uniquely.

Definition at line 129 of file PartitionSwitchAlg.cpp.

129 {
130 auto sc = fwd_<CSTR>(&IPartitionControl::activate,nam);
131 return sc.isSuccess() ? sc : log_(sc, "Cannot activate partition: "+nam);
132 }
PartitionSwitchAlg::log_
StatusCode log_(StatusCode sc, const std::string &msg) const
Definition: PartitionSwitchAlg.cpp:95
merge_files.sc
int sc
Definition: merge_files.py:167
IPartitionControl::activate
virtual StatusCode activate(const std::string &name)=0
Activate a partition object. The name identifies the partition uniquely.

STATUS PartitionSwitchAlg::activate | ( | IInterface * | pPartition | ) |
| inline override

Activate a partition object.

Definition at line 134 of file PartitionSwitchAlg.cpp.

134 {
135 auto sc = fwd_<IInterface*>(&IPartitionControl::activate, pPartition);
136 return sc.isSuccess() ? sc : log_(sc, "Cannot activate partition by Interface.");
137 }
PartitionSwitchAlg::log_
StatusCode log_(StatusCode sc, const std::string &msg) const
Definition: PartitionSwitchAlg.cpp:95
merge_files.sc
int sc
Definition: merge_files.py:167
IPartitionControl::activate
virtual StatusCode activate(const std::string &name)=0
Activate a partition object. The name identifies the partition uniquely.

STATUS PartitionSwitchAlg::activePartition | ( | std::string & | nam,
|  | IInterface *& | pPartition
| ) |  | const
| inline override

Access the active partition object.

Definition at line 144 of file PartitionSwitchAlg.cpp.

144 {
145 auto sc = fwd_<std::string&,IInterface*&>(&IPartitionControl::activePartition,nam,pPartition);
146 return sc.isSuccess() ? sc : log_(sc, "Cannot determine active partition.");
147 }
IPartitionControl::activePartition
virtual StatusCode activePartition(std::string &name, IInterface *&pPartition) const =0
Access the active partition object.
PartitionSwitchAlg::log_
StatusCode log_(StatusCode sc, const std::string &msg) const
Definition: PartitionSwitchAlg.cpp:95
merge_files.sc
int sc
Definition: merge_files.py:167

STATUS PartitionSwitchAlg::create | ( | CSTR | nam,
|  | CSTR | typ
| ) |  |
| inline override

Create a partition object. The name identifies the partition uniquely.

Definition at line 109 of file PartitionSwitchAlg.cpp.

109 {
110 auto sc = fwd_<CSTR,CSTR>(&IPartitionControl::create,nam,typ);
111 return sc.isSuccess() ? sc : log_(sc, "Cannot create partition: "+nam+" of type "+typ);
112 }
PartitionSwitchAlg::log_
StatusCode log_(StatusCode sc, const std::string &msg) const
Definition: PartitionSwitchAlg.cpp:95
IPartitionControl::create
virtual StatusCode create(const std::string &name, const std::string &type)=0
Create a partition object. The name identifies the partition uniquely.
merge_files.sc
int sc
Definition: merge_files.py:167

STATUS PartitionSwitchAlg::create | ( | CSTR | nam,
|  | CSTR | typ,
|  | IInterface *& | pPartition
| ) |  |
| inline override

Create a partition object. The name identifies the partition uniquely.

Definition at line 114 of file PartitionSwitchAlg.cpp.

114 {
115 auto sc = fwd_<CSTR,CSTR,IInterface*&>(&IPartitionControl::create,nam,typ,pPartition);
116 return sc.isSuccess() ? sc : log_(sc, "Cannot create partition: "+nam+" of type "+typ);
117 }
PartitionSwitchAlg::log_
StatusCode log_(StatusCode sc, const std::string &msg) const
Definition: PartitionSwitchAlg.cpp:95
IPartitionControl::create
virtual StatusCode create(const std::string &name, const std::string &type)=0
Create a partition object. The name identifies the partition uniquely.
merge_files.sc
int sc
Definition: merge_files.py:167

STATUS PartitionSwitchAlg::drop | ( | CSTR | nam | ) |
| inline override

Drop a partition object. The name identifies the partition uniquely.

Definition at line 119 of file PartitionSwitchAlg.cpp.

119 {
120 auto sc = fwd_<CSTR>(&IPartitionControl::drop,nam);
121 return sc.isSuccess() ? sc : log_(sc, "Cannot drop partition: "+nam);
122 }
PartitionSwitchAlg::log_
StatusCode log_(StatusCode sc, const std::string &msg) const
Definition: PartitionSwitchAlg.cpp:95
merge_files.sc
int sc
Definition: merge_files.py:167
IPartitionControl::drop
virtual StatusCode drop(const std::string &name)=0
Drop a partition object. The name identifies the partition uniquely.

STATUS PartitionSwitchAlg::drop | ( | IInterface * | pPartition | ) |
| inline override

Drop a partition object. The name identifies the partition uniquely.

Definition at line 124 of file PartitionSwitchAlg.cpp.

124 {
125 auto sc = fwd_<IInterface*>(&IPartitionControl::drop,pPartition);
126 return sc.isSuccess() ? sc : log_(sc, "Cannot drop partition by Interface.");
127 }
PartitionSwitchAlg::log_
StatusCode log_(StatusCode sc, const std::string &msg) const
Definition: PartitionSwitchAlg.cpp:95
merge_files.sc
int sc
Definition: merge_files.py:167
IPartitionControl::drop
virtual StatusCode drop(const std::string &name)=0
Drop a partition object. The name identifies the partition uniquely.

STATUS PartitionSwitchAlg::execute | ( |  | ) |
| inline override

Execute procedure.

Definition at line 81 of file PartitionSwitchAlg.cpp.

81 {
82 if ( m_actor ) {
83 STATUS sc = m_actor->activate(m_partName);
84 if ( !sc.isSuccess() ) {
85 error() << "Cannot activate partition \""
86 << m_partName << "\"!" << endmsg;
87 }
88 return sc;
89 }
90 error() << "The partition control tool \"" << name()
91 << "." << m_toolType << "\" cannot be accessed!" << endmsg;
92 return STATUS::FAILURE;
93 }
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:76
merge_files.sc
int sc
Definition: merge_files.py:167
Algorithm::name
const std::string & name() const override
The identifying name of the algorithm object.
Definition: Algorithm.cpp:820
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:118
PartitionSwitchAlg::m_partName
std::string m_partName
Job option to set the requested partition name.
Definition: PartitionSwitchAlg.cpp:33
StatusCode::FAILURE
Definition: StatusCode.h:29
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
PartitionSwitchAlg::m_actor
IPartitionControl * m_actor
reference to Partition Controller
Definition: PartitionSwitchAlg.cpp:37
IPartitionControl::activate
virtual StatusCode activate(const std::string &name)=0
Activate a partition object. The name identifies the partition uniquely.
PartitionSwitchAlg::m_toolType
std::string m_toolType
Job option to set the tool manipulating the multi-service name.
Definition: PartitionSwitchAlg.cpp:35
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

STATUS PartitionSwitchAlg::finalize | ( |  | ) |
| inline override

Finalize.

Definition at line 73 of file PartitionSwitchAlg.cpp.

73 {
74 SmartIF<IAlgTool> tool(m_actor);
75 if ( tool ) toolSvc()->releaseTool(tool);
76 m_actor = nullptr;
77 return STATUS::SUCCESS;
78 }
SmartIF
Small smart pointer class with automatic reference counting for IInterface.
Definition: IConverter.h:14
Algorithm::toolSvc
SmartIF< IToolSvc > & toolSvc() const
The standard ToolSvc service, Return a pointer to the service if present.
StatusCode::SUCCESS
Definition: StatusCode.h:30
PartitionSwitchAlg::m_actor
IPartitionControl * m_actor
reference to Partition Controller
Definition: PartitionSwitchAlg.cpp:37
IToolSvc::releaseTool
virtual StatusCode releaseTool(IAlgTool *tool)=0
Release the tool.
template<typename... FArgs, typename... Args>

StatusCode PartitionSwitchAlg::fwd_ | ( | StatusCode(IPartitionControl::*)(FArgs...) | fun,
|  | Args &&... | args
| ) |  |
| inline private

Definition at line 100 of file PartitionSwitchAlg.cpp.

100 {
101 return m_actor ? (m_actor->*fun)(std::forward<Args>(args)...) : NO_INTERFACE;
102 }
gaudirun.args
list args
Definition: gaudirun.py:290
fun
double fun(const std::vector< double > &x)
Definition: PFuncTest.cpp:26
PartitionSwitchAlg::m_actor
IPartitionControl * m_actor
reference to Partition Controller
Definition: PartitionSwitchAlg.cpp:37
template<typename... FArgs, typename... Args>

StatusCode PartitionSwitchAlg::fwd_ | ( | StatusCode(IPartitionControl::*)(FArgs...) const | fun,
|  | Args &&... | args
| ) |  | const
| inline private

Definition at line 104 of file PartitionSwitchAlg.cpp.

104 {
105 return m_actor ? (m_actor->*fun)(std::forward<Args>(args)...) : NO_INTERFACE;
106 }
gaudirun.args
list args
Definition: gaudirun.py:290
fun
double fun(const std::vector< double > &x)
Definition: PFuncTest.cpp:26
PartitionSwitchAlg::m_actor
IPartitionControl * m_actor
reference to Partition Controller
Definition: PartitionSwitchAlg.cpp:37

STATUS PartitionSwitchAlg::get | ( | CSTR | nam,
|  | IInterface *& | pPartition
| ) |  | const
| inline override

Access a partition object. The name identifies the partition uniquely.

Definition at line 139 of file PartitionSwitchAlg.cpp.

139 {
140 auto sc = fwd_<CSTR,IInterface*&>(&IPartitionControl::get, nam, pPartition);
141 return sc.isSuccess() ? sc : log_(sc, "Cannot get partition "+nam);
142 }
PartitionSwitchAlg::log_
StatusCode log_(StatusCode sc, const std::string &msg) const
Definition: PartitionSwitchAlg.cpp:95
merge_files.sc
int sc
Definition: merge_files.py:167
IPartitionControl::get
virtual StatusCode get(const std::string &name, IInterface *&pPartition) const =0
Access a partition object. The name identifies the partition uniquely.

STATUS PartitionSwitchAlg::initialize | ( |  | ) |
| inline override

Initialize.

Release old tool

Now check if the partition is present. If not: try to create it

Definition at line 52 of file PartitionSwitchAlg.cpp.

52 {
53 SmartIF<IAlgTool> tool(m_actor);
54 STATUS sc = toolSvc()->retrieveTool(m_toolType,m_actor,this);
55 if ( sc.isFailure() ) {
56 error() << "Unable to load PartitionSwitchTool "
57 << m_toolType << endmsg;
58 return sc;
59 }
61 if ( tool ) toolSvc()->releaseTool(tool);
63 IInterface* partititon = nullptr;
64 sc = m_actor->get(m_partName, partititon);
65 if ( !sc.isSuccess() ) {
66 error() << "Cannot access partition \""
67 << m_partName << "\"" << endmsg;
68 }
69 return sc;
70 }
SmartIF
Small smart pointer class with automatic reference counting for IInterface.
Definition: IConverter.h:14
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:76
merge_files.sc
int sc
Definition: merge_files.py:167
StatusCode::isFailure
bool isFailure() const
Test for a status code of FAILURE.
Definition: StatusCode.h:86
IToolSvc::retrieveTool
StatusCode retrieveTool(const std::string &type, T *&tool, const IInterface *parent=nullptr, bool createIf=true)
Retrieve specified tool sub-type with tool dependent part of the name automatically assigned...
Definition: IToolSvc.h:145
Algorithm::toolSvc
SmartIF< IToolSvc > & toolSvc() const
The standard ToolSvc service, Return a pointer to the service if present.
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:118
PartitionSwitchAlg::m_partName
std::string m_partName
Job option to set the requested partition name.
Definition: PartitionSwitchAlg.cpp:33
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
IInterface
Definition of the basic interface.
Definition: IInterface.h:234
IPartitionControl::get
virtual StatusCode get(const std::string &name, IInterface *&pPartition) const =0
Access a partition object. The name identifies the partition uniquely.
PartitionSwitchAlg::m_actor
IPartitionControl * m_actor
reference to Partition Controller
Definition: PartitionSwitchAlg.cpp:37
IToolSvc::releaseTool
virtual StatusCode releaseTool(IAlgTool *tool)=0
Release the tool.
PartitionSwitchAlg::m_toolType
std::string m_toolType
Job option to set the tool manipulating the multi-service name.
Definition: PartitionSwitchAlg.cpp:35
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

StatusCode PartitionSwitchAlg::log_ | ( | StatusCode | sc,
|  | const std::string & | msg
| ) |  | const
| inline private

Definition at line 95 of file PartitionSwitchAlg.cpp.

95 {
96 error() << msg << " Status=" << sc.getCode() << endmsg;
97 return sc;
98 }
StatusCode::getCode
unsigned long getCode() const
Get the status code by value.
Definition: StatusCode.h:93
merge_files.sc
int sc
Definition: merge_files.py:167
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:118
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

## Member Data Documentation

IPartitionControl* PartitionSwitchAlg::m_actor = nullptr
| private

reference to Partition Controller

Definition at line 37 of file PartitionSwitchAlg.cpp.

std::string PartitionSwitchAlg::m_partName
| private

Job option to set the requested partition name.

Definition at line 33 of file PartitionSwitchAlg.cpp.

std::string PartitionSwitchAlg::m_toolType
| private

Job option to set the tool manipulating the multi-service name.

Definition at line 35 of file PartitionSwitchAlg.cpp.

The documentation for this class was generated from the following file:

- GaudiCommonSvc/src/DataSvc/PartitionSwitchAlg.cpp